﻿using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using Microsoft.AspNetCore.Mvc;
using DWNet.Data;
using OrderDemo.Services;
using Microsoft.AspNetCore.Http;

namespace OrderDemo.Controllers
{
    [Route("api/[controller]/[action]")]
    [ApiController]
    public class WCustomerSelectController : ControllerBase
    {
        private readonly IWCustomerSelectService _service;

        public WCustomerSelectController(IWCustomerSelectService service)
        {
            _service = service;
        }

        // GET api/WCustomerSelect/Open
        [HttpGet]
        [ProducesResponseType(StatusCodes.Status200OK)]
        [ProducesResponseType(StatusCodes.Status500InternalServerError)]
        public ActionResult<IDataStore> Open()
        {
            try
            {
                IDataStore customers = _service.Open();

                // Return Status Code 200 with the Plain JSON
                return Ok(customers);
            }
            catch (Exception e)
            {
                // Return a Status Code of 500 with the Exception Message
                return StatusCode(StatusCodes.Status500InternalServerError, e.Message);
            }
        }
    }
}
