﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using DWNet.Data;

namespace OrderDemo.Services.Impl
{
    public class WOrderMainService : IWOrderMainService
    {
        // The DataContext local variable. (Similar to PB's SQLCA)
        private readonly AppeonDataContext _context;

        // Initializes a new instance of the WOrderMainService class.
        public WOrderMainService(AppeonDataContext Context)
        {
            // Initialize the DataContext variable
            _context = Context;
        }

        public IDataStore DwOrderItemUeRetrieve(string custNo, string orderNo)
        {
            // Create the .NET DataStore; set its Dataobject; and set its DataContext
            IDataStore orderItems = new DataStore("d_orderitem_list", _context);

            // Retrieve the .NET DataStore
            orderItems.Retrieve(custNo, orderNo);

            // Return the .NET DataStore
            return orderItems;
        }

        public IDataStore DwOrderUeRetrieve(string custNo)
        {
            // Create the .NET DataStore; set its Dataobject; and set its DataContext
            IDataStore orders = new DataStore("d_order_list", _context);

            // Retrieve the .NET DataStore
            orders.Retrieve(custNo);

            // Return the .NET DataStore
            return orders;
        }

        public void UeDeleteOrder(string orderNo)
        {
            // Delete Order Items from the database
            _context.SqlExecutor.Execute("DELETE FROM t_orders_items WHERE forderno = @orderNo", orderNo);

            // Delete the Order from the database
            _context.SqlExecutor.Execute("DELETE FROM t_orders WHERE forderno = @orderNo", orderNo);
        }

        public IDataStore UePostOpen()
        {
            // Create the .NET DataStore; set its Dataobject; and set its DataContext
            IDataStore customers = new DataStore("d_customer_list", _context);

            // Retrieve the .NET DataStore
            customers.Retrieve();

            // Return the .NET DataStore
            return customers;
        }
    }
}
